/* $Id: xnd_t_dep.h,v 1.1.1.1 1999/11/30 08:46:00 berar Exp $ */
/* xnd_t_dep.h        allows to modify           */
/* the internal structure of referenced types    */
/* --------------------------------------------- */
/* --------------------------------------------- */
#ifdef USE_VAR
#include "xnd_t_var.h"
#define VAR_PTR  TYPE_VAR *
#else
#define VAR_PTR  void *
#endif
/* --------------------------------------------- */
#ifdef USE_KEYS
#include "xnd_t_keys.h"
#endif
/* --------------------------------------------- */
#ifdef USE_SETS
#include "xnd_t_sets.h"
#define SETS_PTR  TYPE_SETS *
#else
#define SETS_PTR  void *
#endif
/* --------------------------------------------- */
#ifdef USE_SYM
#include "xnd_t_sym.h"
#define SYMGRP_PTR  TYPE_SYMGRP *
#else
#define SYMGRP_PTR  void *
#endif
/* --------------------------------------------- */
#ifdef USE_MODUL
#include "xnd_t_modul.h"
#define MODUL_PTR  TYPE_MODUL *
#define SATEL_PTR  TYPE_SATEL *
#else
#define MODUL_PTR  void *
#define SATEL_PTR  void *
#endif
/* --------------------------------------------- */
#ifdef USE_BRAGG
#include "xnd_t_bragg.h"
#define BRAGG_PTR  TYPE_BRAGG *
#else
#define BRAGG_PTR  void *
#endif
/* --------------------------------------------- */
#ifdef USE_RBRG
#include "xnd_t_rbrg.h"
#define RBRG_PTR  TYPE_RBRG *
#else
#define RBRG_PTR  void *
#endif
/* --------------------------------------------- */
#ifdef USE_RPRO
#include "xnd_t_rpro.h"
#define RPRO_PTR  TYPE_RPRO *
#else
#define RPRO_PTR  void *
#endif
/* --------------------------------------------- */
#ifdef USE_SCAN
#include "xnd_t_scan.h"
#define SCAN_PTR  TYPE_SCAN *
#else
#define SCAN_PTR  void *
#endif
/* --------------------------------------------- */
#ifdef USE_EXPER
#include "xnd_t_exper.h"
#define EXPER_PTR  TYPE_EXPER *
#else
#define EXPER_PTR  void *
#endif
/* --------------------------------------------- */
#ifdef USE_DIFDAT
#include "xnd_t_difdat.h"
#define DIFDAT_PTR  TYPE_DIFDAT *
#define ANODAT_PTR  TYPE_ANODAT *
#else
#define DIFDAT_PTR  void *
#define ANODAT_PTR  void *
#endif
/* --------------------------------------------- */
#ifdef USE_OBS
#include "xnd_t_obs.h"
#define OBS_PTR  TYPE_OBS *
#else
#define OBS_PTR  void *
#endif
/* --------------------------------------------- */
#ifdef USE_HKLOBS
#include "xnd_t_hklobs.h"
#define HKLOBS_PTR  TYPE_HKLOBS *
#else
#define HKLOBS_PTR  void *
#endif
/* --------------------------------------------- */
#ifdef USE_ATOM
#include "xnd_t_atom.h"
#define ATOM_PTR  TYPE_ATOM *
#else
#define ATOM_PTR  void *
#endif
/* --------------------------------------------- */
#ifdef USE_PENAL
#include "xnd_t_penal.h"
#define PENAL_PTR  TYPE_PENAL *
#define RADIAL_PTR TYPE_RADIAL *
#else
#define PENAL_PTR   void *
#define RADIAL_PTR  void *
#endif
/* --------------------------------------------- */
#ifdef USE_PHASE
#include "xnd_t_phase.h"
#define PHASE_PTR  TYPE_PHASE *
#else
#define PHASE_PTR  void *
#endif
/* --------------------------------------------- */
#ifdef USE_PSEUDO
#include "xnd_t_pseudo.h"
#define PSEUDO_PTR  TYPE_PSEUDO *
#else
#define PSEUDO_PTR  void *
#endif
/* --------------------------------------------- */
/* --------------------------------------------- */


