/* $Id: xnd_t_rbrg.h,v 1.1.1.1 1999/11/29 08:43:00 berar Exp $ */
/* xnd_t_rbrg.h    residual on bragg structure   */
/* --------------------------------------------- */
#ifndef  XND_T_RBRG_H_INCLUDED  /* included once only */
#define  XND_T_RBRG_H_INCLUDED
/* ---------------------------------------------- */

typedef struct
{  float   io;
   float   fo;
   float   wio;
   float   wfo;
   float   di;
   float   df;
   float   wdi;
   float   wdf;
   int     ni;
   int     nf;
   }    TYPE_RBRG;

/*  --------------------------------------------- */
extern TYPE_RBRG  o_brg  ;  	/* overall Bragg factors */     
/*  --------------------------------------------- */
/* in XND_BRG.C  R_Bragg */
void  brg_file     PROTO((void));
void  brg_residual PROTO((void));
void  brg_ini_residual PROTO((TYPE_RBRG *one));
void  brg_add_hkl PROTO((TYPE_RBRG *brg, TYPE_RBRG *one));
void  brg_fprintf PROTO((FILE *file, char *txt, TYPE_RBRG *brg));
/*  --------------------------------------------- */
/* --------------------------------------------- */
#endif          /*  XND_T_RBRG_H_INCLUDED       */
/* --------------------------------------------- */

