/* $Id: xnd_t_cplx.h,v 1.1 2002/01/10 16:03:30 berar Exp $ */
/* XND_t_cplx.c  header for complex functions used in xnd     */
/* ---------------------------------------------------------- */
/* ---------------------------------------------------------- */
#ifndef XND_CMPLX_H_INCLUDED     /* included once only */
#define XND_CMPLX_H_INCLUDED
/* ---------------------------------------------------------- */
typedef struct FCOMPLEX {float r,i;} fcomplex;
/* ---------------------------------------------------------- */
fcomplex Cadd(fcomplex a, fcomplex b);
fcomplex Csub(fcomplex a, fcomplex b);
fcomplex Cmul(fcomplex a, fcomplex b);
fcomplex Complex(float re, float im);
fcomplex Conjg(fcomplex z);
fcomplex Cdiv(fcomplex a, fcomplex b);
float Cabs(fcomplex z);
fcomplex Csqrt(fcomplex z);
fcomplex RCmul(float x, fcomplex a);
fcomplex Catan(fcomplex a);
fcomplex Catan2(fcomplex a, fcomplex b);
fcomplex Catanh(fcomplex a);
fcomplex Ctan(fcomplex a);
/* ---------------------------------------------------------- */
#endif
