static char *cvs_id =" $Id: xnd_r12.c,v 1.3 2002/05/02 12:43:28 berar Exp $ ";
/* XND_R12.C    read 1.2 headers */

#define USE_VAR
#define USE_KEYS

#include "../xnd_def.h"
#include "xnd_rdh.h"
/* ------------------------------------------------------------------ */
/* mode d'ouverture des fichiers */
#ifdef MSDOS
#define R_MODE  "rb"
#define W_MODE  "w+b"
#else
#define R_MODE  "r"
#define W_MODE  "w+"
#endif
/* ------------------------------------------------------------------ */
#define REMARK_PAR 6
/* ------------------------------------------------------------------ */
int get_12hdr(P_(void))
{ int  irem = 0;
  char base_name[100], buf[11], *car;
  long filepos;
  FILE *tf;
  char *rem_xnd = NULL;
  int  var_mask;
  push_err_msg("get_12hdr(xnd_r12.c)");
  filepos = ftell(coord_fich);
  purge_cr();
  filepos = ftell(coord_fich);
  if ( fscanf(coord_fich, " %[@#]", buf) != 1  )
  {   pop_err_msg();
      return 0;
		}
  ungetc(buf[0], coord_fich);
  /* fseek(coord_fich, filepos, 0);    */
  tf = tmpfile();
  list_fich = tf;
  fprintf (list_fich, " %s : %s [%s:%s]\n\n%s\n Reference : %s\n\n xnd_1.2x header mode\n\n",
     lect->prg_name, xnd_release(), xnd_host(), xnd_kernel(), xnd_ref(), xnd_pub());
  verbose_printf ("\n  %s\n", titre);
  strcpy(base_name, lect->coord_name);
  car = strrchr(base_name, '.');
  if ( car ) *car =0;
  strcpy(list_name, base_name);
  strcat(list_name, ".lst");
  strcpy(new_name, base_name);
  strcat(new_name, ".new");
  strcpy(hkl_name, base_name);
  strcat(hkl_name, ".hkl");
  strcpy(plg_name, base_name);
  strcat(plg_name, ".plg");
  strcpy(cif_name, base_name);
  strcat(cif_name, ".cif");
  read_remark( &rem_xnd );
  if ( get_keys( "XND", NULL,
          "CYCLE", KEYTYPE_INT, &max_cycle, (int) KEY_XND_CYCLE, 
          "PHASE", KEYTYPE_INT, &n_phase,   (int) KEY_XND_PHASE,
          "EXPER", KEYTYPE_INT, &n_exper,   (int) KEY_XND_EXPER,
          "SYM",   KEYTYPE_INT, &lect->nl_sym, (int) 0,
          "ANO",   KEYTYPE_INT, &lect->nl_ano, (int) 0,
          "DIF",   KEYTYPE_INT, &lect->nl_dif, (int) 0,
	  "LST",   KEYTYPE_CHAR, &list_name, list_name,
	  "NEW",   KEYTYPE_CHAR, &new_name,  new_name,
	  "PLG",   KEYTYPE_CHAR, &plg_name,  plg_name,
	  "HKL",   KEYTYPE_CHAR, &hkl_name,  hkl_name,
	  "CIF",   KEYTYPE_CHAR, &cif_name,  cif_name,
           NULL ) == -1 ) 
  {   pop_err_msg();
      return 0; /* back to 1.1 header */
		}
  /* we are now using 1.2 headers, end of init */
	lect->rem_nb = REMARK_PAR;
	lect->rem0=(char **) tst_alloc(REMARK_PAR, sizeof(char*), "rem0");
	memset(lect->rem0, 0, REMARK_PAR*sizeof(char *));
	lect->rem0[irem++]=rem_xnd;
	fprintf (list_fich,"\n");

  list_fich = freopen ( list_name, "w", stderr);
  if (list_fich==NULL)
  {  printf (E_FOPEN, "listing", list_name);
     exit (10);
     }
  fflush(tf);
  fseek(tf, 0, 0);
  while( !feof(tf) )
  {  if (fread(buf ,1 ,1 , tf) == 1)
     fwrite( buf, 1, 1, list_fich);
     }
  fclose(tf);  
  
  verbose_printf ("\n files '%s' --> '%s' : %s %s\n", lect->coord_name, list_name, 
                  host, str_time);
  fprintf(list_fich,"\n Number of cycle(s) : %d\n\
 Number of experiment(s) : %d , Number of phase(s) : %d\n\
 Symetry group(s) : %d , Anomalous diffusion table(s) : %d , Scattering table(s) : %d\n",
 max_cycle, n_exper, n_phase, lect->nl_sym, lect->nl_ano, lect->nl_dif);
  fprintf(list_fich,"\n Current files names are :\n '%s' (new coordinates), '%s' (hkl intensities), '%s' (plot)\n\n",
   new_name, hkl_name, plg_name);
fflush(list_fich);

   /* modes parameters */
   read_remark(&(lect->rem0[irem++]));
	eps_stop = KEY_MODES_STOP; eps_prof = KEY_MODES_PROF; relax = KEY_MODES_RELAX;
	get_keys( "MODES", NULL,
          "LSQ",     KEYTYPE_INT,  &mod_lsq,         (int) 0,
          "BGROUND", KEYTYPE_INT,  &lect->back_code, (int) 0,
          "PROFILE", KEYTYPE_INT,  &voigt_mode,      (int) 0,
          "ORDER",   KEYTYPE_INT,  &lect->max_ordre, (int) KEY_MODES_ORDER,
			 "ASYM",   KEYTYPE_INT,  &max_asym,       (int) KEY_MODES_ASYM,
			 "STOP",    KEYTYPE_FLOAT, &eps_stop,       &eps_stop,
			 "PROF",    KEYTYPE_FLOAT, &eps_prof,       &eps_prof ,
			 "RELAX",   KEYTYPE_FLOAT, &relax,          &relax,
			 "VAR_MODE", KEYTYPE_INT,  &var_mask,       (int) 0,
           NULL );

   fprintf (list_fich,"\n The method code %d implies ", mod_lsq);
   if (mod_lsq ) fprintf (list_fich,": %s, %s, %s, %s\n",
      mod_lsq & 1 ? "min.lin.":" ", mod_lsq & 2 ? "w(y_calc)":" ",
      mod_lsq & 4 ? "correl.":" ", mod_lsq & 8 ? "x_back":" ");
   else fprintf (list_fich,"defaults\n");
   back_mode = lect->back_code & 0x3;
   unc_mode  = (lect->back_code & 0xC) >> 2;
   switch ( back_mode)
   {  case 0 : car = "interpol"; break;
      case 1 : car = "spline"; break;
      case 2 : car = "polynomial tth"; break;
      case 3 : car = "q-2 polynomial expension"; break;
      default : car = "???"; break;
      }
   fprintf (list_fich," The background code %d implies : %s%s%s\n",
		lect->back_code, car, (unc_mode&1)!=0?", adding uncoherent":"",
		(unc_mode&2)!=0?", printing uncoherent":"");
   fprintf (list_fich," The profile code %d implies : %svoigt\n\n",
	  voigt_mode, voigt_mode==0?"pseudo":"");
   fprintf (list_fich," Parameters expansion order %d \n", lect->max_ordre );
	var_init_mode(var_mask);
	init_asym_function();

   /*   output control parameters */
   prt_new = prt_plg = prt_hkl =1;
   read_remark(&(lect->rem0[irem++]));
	get_keys( "OUTPUT", NULL,
          "NEW",  KEYTYPE_INT, &prt_new, prt_new,
          "PLG",  KEYTYPE_INT, &prt_plg, (int) 1,
          "HKL",  KEYTYPE_INT, &prt_hkl, (int) 1,
          "SYM",  KEYTYPE_INT, &(lect->prt_sym), (int) 0,
          "DIF",  KEYTYPE_INT, &(lect->prt_dif), (int) 0,
          "COR",  KEYTYPE_INT, &prt_cor, (int) 5,
			 "KEY",  KEYTYPE_INT, &key_mode, key_mode,
			 "CIF",  KEYTYPE_INT, &prt_cif, (int) 0,
           NULL );
   if (prt_new) 
   {   prt_new ++;
       tst_abort ((strcmp(new_name,lect->coord_name)==0), "NEW file is the same than the coord file");
       fprintf (list_fich," The new file '%s' will be produced with serial number #%d\n", new_name, prt_new);
		 }
	else fprintf (list_fich," prt_new =0 : No NEW file will be produced\n");
   if (prt_plg) 
   {  fprintf(list_fich," The plg code %d implies \"%s %s %s\" option(s) in %s\n",
             prt_plg,
             prt_plg&PLG_NHEADER?"no_header":"",
             prt_plg&PLG_ADDEND?"add_endrecord":"",
             prt_plg&PLG_ADDSEMI?"add_semicolumn":"", 
             prt_plg&PLG_QSTEP?"q_steps":"", 
             plg_name);
       }
   else fprintf(list_fich," prt_plg =0 : No PLG file will be produced\n");
   if (prt_hkl) 
   {  fprintf(list_fich," The hkl code %d implies : %s \n", prt_hkl,
             prt_hkl&6?"Printing non calculated lines":"");
       }
   else fprintf(list_fich," prt_plg =0 : No HKL file will be produced\n");
   if (prt_cif && prt_cif != -1) 
   {   if (cycle )fprintf (list_fich," Data for cif will be generated in '%s'\n", cif_name);
	    else fprintf (list_fich," cif file '%s' will not contain standard deviation : cycle = 0\n", cif_name);
		 }
	  
   /* various old parameters, some are probably no more usefull */
   fprintf (list_fich,"\n");
	/* lect->data_path is initialised using prg_id in xnd_rd.c */
   read_remark(&(lect->rem0[irem++]));
	get_keys( "OTHERS", NULL,
          "VALID",  KEYTYPE_INT, &valid_ref, (int) 1,
          "DYDP",   KEYTYPE_INT,    &disk_dydp, (int) 0,
          "DATA",   KEYTYPE_INT,    &disk_data, (int) 0,
          "TMPDEF", KEYTYPE_INT,    &(lect->tmp_default), (int) 0,
			 "DNAME",  KEYTYPE_STRING, &(data_name),      (char *) "",
			 "TMP",    KEYTYPE_STRING, &(lect->tmp_path), (char *) "",
			 "PATH",   KEYTYPE_STRING, &(lect->data_path),(char *) NULL,
           NULL );
  
    if (valid_ref > 1)
    {  lect->valid_reste = abs(prt_new) % valid_ref;
       fprintf (list_fich,"\nvalid_ref non nul ==> affinement restreint :\n\
 1 < code < 10 : (code - 2) modulo %d == %d ==> codes affines %d, %dxx\n",
 valid_ref, lect->valid_reste, 2+lect->valid_reste, 2+lect->valid_reste );
      }
   read_remark(&(lect->rem0[irem++]));

   /* test parameters are to be read now, if they exist */
   asym_rmin = KEY_TEST_RMIN; asym_rmax = KEY_TEST_RMAX;
   asym_resol = KEY_TEST_RESOL; asym_width = KEY_TEST_WIDTH;
	bragg_repart = KEY_TEST_REPART;
	if (get_keys( "TEST", "EXPER",
           "PRINT",   KEYTYPE_INT,    &test_mode, (int) 0,
			  "AS_RMIN", KEYTYPE_FLOAT,  &asym_rmin, &asym_rmin,
			  "AS_RMAX", KEYTYPE_FLOAT,  &asym_rmax, &asym_rmax,
			  "AS_RESOL", KEYTYPE_FLOAT, &asym_resol, &asym_resol,
			  "AS_WIDTH", KEYTYPE_FLOAT, &asym_width, &asym_width,
			  "BRG_RATIO", KEYTYPE_FLOAT, &bragg_repart, &bragg_repart,
			   NULL ) > 0)
	{  test_mode |= 0x100;
	   if (test_mode & 0x01)  verbose_printf("test : print & 0x01 -> prints out matrix and vectors\n");
	   if (test_mode & 0x02)  verbose_printf("test : print & 0x02 -> prints out in pseudo-voigt\n");
	   if (test_mode & 0x04)  verbose_printf("test : print & 0x04 -> prints out on convol asym\n");
      read_remark(&(lect->rem0[irem++]));
	   }
   tst_abort(irem > REMARK_PAR, " irem > REMARK_PAR, please report!");
	pop_err_msg();
   return 1;
   }
/* ------------------------------------------------------------------ */
int new_12hdr(P_(void))
{ int  irem = 0;
  int  new_asym;
  char base_name[100], lst_def[100], new_def[100], *car;
  char hkl_def[100], plg_def[100], cif_def[100], path_def[100];
  float def_prof, def_stop, def_relax;
  
  new_fich = tst_open ( new_name, "w", "NEW file");
  fprintf (new_fich,"%s\n", titre);
  
  strcpy(base_name, lect->coord_name);
  car = strrchr(base_name, '.');
  if (car) *car=0;
  strcpy(lst_def, base_name);
  strcat(lst_def, ".lst");
  strcpy(new_def, base_name);
  strcat(new_def, ".new");
  strcpy(hkl_def, base_name);
  strcat(hkl_def, ".hkl");
  strcpy(plg_def, base_name);
  strcat(plg_def, ".plg");
  strcpy(cif_def, base_name);
  strcat(cif_def, ".cif");
  if (strlen(cif_name)==0) strcpy(cif_name, cif_def);
  if (lect->rem0[irem++]) fprintf(new_fich,"%s", lect->rem0[irem-1]);
  new_keys("XND",  
		"CYCLE", KEYTYPE_INT, FEW_KEY, max_cycle, (int) KEY_XND_CYCLE,
      "EXPER", KEYTYPE_INT, EXT_KEY, n_exper,   (int) KEY_XND_EXPER,
      "PHASE", KEYTYPE_INT, EXT_KEY, n_phase,   (int) KEY_XND_PHASE,
      "SYM",   KEYTYPE_INT, EXT_KEY, lect->nl_sym, (int) 0,
      "ANO",   KEYTYPE_INT, EXT_KEY, lect->nl_ano, (int) 0,
      "DIF",   KEYTYPE_INT, EXT_KEY, lect->nl_dif, (int) 0,
		"LST",   KEYTYPE_CHAR, ALL_KEY, list_name, lst_def,
		"NEW",   KEYTYPE_CHAR, ALL_KEY, new_name, new_def,
		"PLG",   KEYTYPE_CHAR, ALL_KEY, plg_name, plg_def,
		"HKL",   KEYTYPE_CHAR, ALL_KEY, hkl_name, hkl_def,
		"CIF",   KEYTYPE_CHAR, ALL_KEY, cif_name, cif_def,
       NULL ) ;
  fprintf(new_fich,"\n");
  if (lect->rem0[irem++]) fprintf(new_fich,"%s", lect->rem0[irem-1]);
  def_stop = KEY_MODES_STOP;
  def_prof = KEY_MODES_PROF;
  def_relax = KEY_MODES_RELAX;
  if (asym_mode == 0) new_asym = 0; 
  else if (asym_mode == 2) new_asym = -max_asym;
  else new_asym = max_asym;
  new_keys( "MODES",  
      "LSQ",      KEYTYPE_INT, EXT_KEY, mod_lsq,         (int) 0,
      "BGROUND",  KEYTYPE_INT, EXT_KEY, lect->back_code, (int) 0,
      "PROFILE",  KEYTYPE_INT, EXT_KEY, voigt_mode,      (int) 0,
      "ORDER",    KEYTYPE_INT, EXT_KEY, lect->max_ordre, (int) KEY_MODES_ORDER,
		"ASYM",    KEYTYPE_INT, EXT_KEY,  new_asym,      (int) KEY_MODES_ASYM,
		"STOP",    KEYTYPE_FLOAT, STD_KEY, &eps_stop,      &def_stop,
		"PROF",    KEYTYPE_FLOAT, EXT_KEY, &eps_prof,      &def_prof ,
		"RELAX",   KEYTYPE_FLOAT, EXT_KEY, &relax,         &def_relax,
           NULL );
  fprintf(new_fich,"\n");
  if (lect->rem0[irem++]) fprintf(new_fich,"%s", lect->rem0[irem-1]);
	new_keys( "OUTPUT",  
          "NEW",  KEYTYPE_INT, STD_KEY, prt_new, (int) 1,
          "PLG",  KEYTYPE_INT, EXT_KEY, prt_plg, (int) 1,
          "HKL",  KEYTYPE_INT, EXT_KEY, prt_hkl, (int) 1,
          "SYM",  KEYTYPE_INT, EXT_KEY, lect->prt_sym, (int) 0,
          "DIF",  KEYTYPE_INT, EXT_KEY, lect->prt_dif, (int) 0,
          "COR",  KEYTYPE_INT, EXT_KEY, prt_cor, (int) 0,
			 "KEY",  KEYTYPE_INT, ALL_KEY, key_mode, (int) STD_KEY,
          "CIF",  KEYTYPE_INT, EXT_KEY, prt_cif, (int) 0,
           NULL );
  fprintf(new_fich,"\n");
  if (lect->rem0[irem++]) fprintf(new_fich,"%s", lect->rem0[irem-1]);
  make_path (path_def, lect->data_path, "");
	new_keys( "OTHERS",  
          "VALID",  KEYTYPE_INT, EXT_KEY,    valid_ref, (int) 0,
          "DYDP",   KEYTYPE_INT, ALL_KEY,    disk_dydp, (int) 0,
          "DATA",   KEYTYPE_INT, ALL_KEY,    disk_data, (int) 0,
          "TMPDEF", KEYTYPE_INT, ALL_KEY,    lect->tmp_default, (int) 0,
			 "DNAME",  KEYTYPE_STRING, ALL_KEY, &(data_name),      (char *) "",
			 "TMP",    KEYTYPE_STRING, ALL_KEY, &(lect->tmp_path), (char *) "",
			 "PATH",   KEYTYPE_STRING, ALL_KEY, &(lect->data_path), path_def,
           NULL );
  fprintf(new_fich,"\n");
  if (lect->rem0[irem++]) fprintf(new_fich,"%s", lect->rem0[irem-1]);
  if (test_mode)
  {  float def_rmin, def_rmax, def_resol, def_width, def_repart;
     def_rmin = KEY_TEST_RMIN; def_rmax = KEY_TEST_RMAX;
     def_resol = KEY_TEST_RESOL; def_width = KEY_TEST_WIDTH;
	  def_repart = KEY_TEST_REPART;
     new_keys( "TEST",  
        "PRINT",    KEYTYPE_INT,   EXT_KEY, test_mode && 0xFF, (int) 0,
		  "AS_RMIN",  KEYTYPE_FLOAT, EXT_KEY, &asym_rmin, &def_rmin,
		  "AS_RMAX",  KEYTYPE_FLOAT, EXT_KEY, &asym_rmax, &def_rmax,
		  "AS_RESOL", KEYTYPE_FLOAT, EXT_KEY, &asym_resol, &def_resol,
		  "AS_WIDTH", KEYTYPE_FLOAT, EXT_KEY, &asym_width, &def_width,
		  "BRG_RATIO", KEYTYPE_FLOAT,EXT_KEY, &bragg_repart, &def_repart,
        NULL );
     if (lect->rem0[irem++]) fprintf(new_fich,"\n%s", lect->rem0[irem-1]);
	  }

   return 1;

  }
/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */

