/* $Id: xnd_t_difdat.h,v 1.1.1.1 1999/11/17 22:09:00 berar Exp $ */
/* xnd_t_difdat.h  header for difdat structure   */
/* --------------------------------------------- */
#ifndef  XND_T_DIFDAT_H_INCLUDED  /* included once only */
#define  XND_T_DIFDAT_H_INCLUDED
/* ---------------------------------------------- */
/* ---------------------------------------------- */

typedef struct
{     char    nom[8];
      char    cas;        /* 0 = constante, 1 = table interp, 2 TIC, 3 hadju ... */
      int     tot;        /* 0  = expression TIC ou nb de pts */
      float   s;
      float   act;
      float   coef;       /* rx = (9TIC) (ds,nval), neut=(val)  */
	   }   TYPE_DIFDAT;

typedef struct
{     char    nom[8];
      int     tot;        /* nb de grp de data anomal */
      float   coef[3];    /* lambda, f', f", current values */
      float  *lambda;
      VAR_PTR fano;
      }   TYPE_ANODAT;

/* --------------------------------------------- */
/* defined in XND_RDIF.C */

TYPE_DIFDAT *get_dif     PROTO((char *modele, int fatal));
TYPE_ANODAT *get_adif    PROTO((char *modele));
void    lecture_ano PROTO((void));
void put_dif        PROTO((TYPE_DIFDAT * difdat, FILE *file));
void new_dif        PROTO((TYPE_DIFDAT * difdat));
TYPE_DIFDAT *lecture_dif PROTO((FILE *file, TYPE_DIFDAT * mem));
/* --------------------------------------------- */
/* --------------------------------------------- */
#endif          /*  XND_T_DIFDAT_H_INCLUDED       */
/* --------------------------------------------- */
